{$G+}
{DK}
Unit VGA;

Interface

type
  TPoint = Record
    X, Y : Integer;
  End;

  TRect = Record
    A, B : TPoint;
  End;

  PPaintInfo = ^TPaintInfo;
  TPaintInfo = Record
    Fore, Back : Byte;                      {fore/backing colors}
    Operation  : Byte;                      {drawing logic mode, 0..21}
    LinePattern: Word;                      {16x1 pattern for lines - psXXXX}
    LineStyle  : Byte;                      {figure filling style   - lsXXXX}
    LineWidth  : Byte;                      {for FillEllipse/Line   - lwXXXX}
    BitMapOrg  : TPoint;                    {for lsBitmapOrg mode}
    ClipRect   : TRect;                     {clipping rectangle}

    Font       : Byte;                      {font number          }
    FontWidth  : Word;                      {average symbol width }
    FontHeight : Word;                      {average symbol height}
    GapLength  : Word;                      {space between symbols}
    Escapement : Word;                      {direction in degrees }
    Italic     : Byte;                      {skewing factor       }
    FontStyle  : Word;                      {mixed styles         }

    Device     : Pointer;
  End;


Procedure StartVGA; Inline($B8/$13/$00/$CD/$10);
Procedure EndVGA; Inline($B8/$03/$00/$CD/$10);

Procedure SetVGAPalette(First, Count : Word; PBuf : Pointer);

Procedure PutPixel(X, Y : Integer; Color : Byte);
Procedure Line(RAX, RAY, RBX, RBY : Integer; var T : TPaintInfo);
Procedure HLine(X1, X2, Y : Word; Color : Byte);
Procedure Bar(X1, Y1, X2, Y2 : Word; Color : Byte);
procedure Triangle(x1, y1, x2, y2, x3, y3 : integer; C : Byte);

Var
  YLines   : array[0..199] of Word;
  VideoSeg : Word;

Implementation

Uses EgInline, Reals;

Procedure PutPixel(X, Y : Integer; Color : Byte); Assembler;
Asm
  mov ax, VideoSeg
  mov es, ax
  mov si, Y
  shl si, 1
  mov bx, offset YLines
  mov si, [si+bx]
  add si, X
  mov al, Color
  mov es:[si], al
End;

Procedure SetVGAPalette(First, Count : Word; PBuf : Pointer); Assembler;
Asm
    push bp
    push cx
    mov ah, 10h
    mov al, 12h
    mov bx, First
    mov cx, Count
    mov dx, word ptr pbuf+2
    mov es, dx
    mov dx, word ptr pbuf
    int 10h
    pop cx
    pop bp
End;


Procedure Line(RAX, RAY, RBX, RBY : Integer; var T : TPaintInfo);
Var
  DI_Y_IN, DI_X_IN, SH_DI, ST_X_IN, ST_Y_IN, ST_CO, DI_CO : Word;
  Pattern : Word;
  X, Y : Integer;
  I : Byte;
Begin
asm
    les di, T
    mov ax, es:[di].TPaintInfo.LinePattern
    mov Pattern, ax
    mov cx, 1
    mov dx, 1
    mov di, RBY
    sub di, RAY
    jge @@KEEP_Y
    neg dx
    neg di
  @@KEEP_Y:mov DI_Y_IN, dx
    mov si, RBX
    sub si, RAX
    jge @@KEEP_X
    neg cx
    neg si
  @@KEEP_X:mov DI_X_IN, cx

    cmp si, di
    jge @@HORS
    xor cx, cx
    xchg si, di
    jmp @@SAVS
@@HORS:xor dx, dx
{?}    inc si
@@SAVS:mov SH_DI, di
    mov ST_X_IN, cx
    mov ST_Y_IN, dx
    mov ax, SH_DI
    shl ax, 1
    mov st_co, ax
    sub ax, si
    mov bx, ax
    sub ax, si
    mov DI_CO, ax
    inc si
{}
    xor ax, ax
    mov X, ax
    mov Y, ax
    les di, T
    mov al, es:[di].TPaintInfo.LineWidth
    mov I, al
    cmp al, 1 {᫨ ⮫騭 = 1 業஢  ॡ}
    jbe @@10
    mov cl, al
    shr cl, 1
    xor ch, ch
    mov ax, ST_X_IN
    imul cl
    sub RAY, ax
    mov y, ax
    mov ax, ST_Y_IN
    imul cl
    sub RAX, ax
    mov x, ax
  @@10:

    mov cx, RAX
    mov dx, RAY
  @@MLOOP:
     dec si
     jz @@FINIS
     ror Pattern, 1
     push cx
     push dx
     les di, T
     mov al, es:[di].TPaintInfo.LineWidth
     mov I, al
  @@Width:
{}   dec I

     les di, T
     cmp cx, es:[di].TPaintInfo.ClipRect.A.X
     jl @@8
     cmp cx, es:[di].TPaintInfo.ClipRect.B.X
     jge  @@8
     cmp dx, es:[di].TPaintInfo.ClipRect.A.Y
     jl @@8
     cmp dx, es:[di].TPaintInfo.ClipRect.B.Y
     jge  @@8
     mov ax, Pattern
     and ax, 1
     mov al, es:[di].TPaintInfo.Fore
     jne @@9
     mov al, es:[di].TPaintInfo.Back
@@9:
     push cx
     push dx
     push bx
     push si
     push di

     {normal line, any line width}

     {mov bx, VideoSeg
     mov es, bx}
     les di, T
     les bx, es:[di].TPaintInfo.Device
     mov di, dx
     mov bx, di
     shl bx, 2
     add di, bx
     shl di, 6
     add di, cx
     mov es:[di], al


     pop  di
     pop  si
     pop  bx
     pop  dx
     pop  cx

  @@8:
{}   add  cx, ST_Y_IN
     add  dx, ST_X_IN
     cmp  I, 0
     jne @@Width
     pop dx
{}   pop cx

    cmp bx, 0
    jge @@DILIN
    add cx, ST_X_IN
    add DX, ST_Y_IN
    add BX, ST_CO
    jmp  @@MLOOP
@@DILIN:add cx, DI_X_IN
    add dx, DI_Y_IN
    ADD BX, DI_CO
    jmp @@MLOOP
  @@FINIS:
end;
End;

Procedure HLine(X1, X2, Y : Word; Color : Byte); Assembler; Asm
  mov dx, x1
  mov cx, x2
  cmp dx, cx
  jle  @@0
  xchg dx, cx
@@0:
  mov ax, VideoSeg
  mov es, ax
  mov si, Y
  shl si, 1
  mov bx, offset YLines
  mov di, [si+bx]
  sub cx, dx
  add di, dx
  cld
  mov al, Color
  rep stosb
End;

Procedure Bar(X1, Y1, X2, Y2 : Word; Color : Byte);
Var
  I : Integer;
Begin
  for I := Y1 to Y2 do HLine(X1, X2, I, Color);
End;

procedure Triangle(x1, y1, x2, y2, x3, y3 : integer; c : Byte);
Var
  tmp,tmpx,tmpy:integer;
  add1,add2:LongInt; {}
  xl1,xl2:TSingle;
begin;
  if y1>y2 then begin
    tmpy:=y1; tmpx:=x1; {} y1:=y2; x1:=x2;
    y2:=tmpy; x2:=tmpx;
  end;
  if y1>y3 then begin
    tmpy:=y1; tmpx:=x1; {} y1:=y3; x1:=x3;
    y3:=tmpy; x3:=tmpx;
  end;
  if y2>y3 then begin
    tmpy:=y2; tmpx:=x2; {} y2:=y3; x2:=x3;
    y3:=tmpy; x3:=tmpx;
  end;

  tmp := y2 - y1;
  if tmp=0 then inc(tmp);
  add1  := ((LongInt(x2 - x1)) shl 16) div tmp;

  tmp := y3 - y1;
  if tmp = 0 then inc(tmp);
  add2  := ((LongInt(x3 - x1)) shl 16) div tmp;

  xl1.int  := x1; xl1.frac := 0; xl2  := xl1;
  if y1 < 0 then begin
    y1 := -y1;
    inc(xl1.l, add1 * y1);
    inc(xl2.l, add2 * y1);
    y1 := 0;
  end;

  if (y2 >= 0) and (y1 < 199) then for tmp := y1 to MinInteger(199, y2) do begin
    if (tmp >= 0)
    then Hline(MaxInteger(0, xl1.iint), MinInteger(319, xl2.iint), tmp, c);
    inc(xl1.l, add1);   inc(xl2.l, add2);
  end;
  if (y2 > 199) or (y3 < 0) then Exit;

  dec(xl2.l, add2);

  tmp:= y3 - y2;
  if tmp = 0 then inc(tmp);
  add1  := ((LongInt(x3 - x2)) shl 16) div tmp;

  xl1.int := x2; xl1.frac := 0;

  if y2 < 0 then begin
    y2 := -y2;
    inc(xl1.l, add1 * y2);
    inc(xl2.l, add2 * y2);
    y2 := 0;
  end;
  for tmp := y2 to MinInteger(199, y3) do begin;
    if (tmp >= 0)  then
    Hline(MaxInteger(0, xl1.iint), MinInteger(319, xl2.iint), tmp, c);
    inc(xl1.l, add1);  inc(xl2.l, add2);
  end;
end;



Procedure StartCalc;
Var
  I : Byte;
Begin
  for I := 0 to 199 do YLines[I] := I * 320;
End;

Begin
  StartCalc;
  VideoSeg := SegA000;
End.